"""
    ai/h2o/engine/v1/h2o_version_service.proto

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: version not set
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from h2o_engine_manager.gen.h2o_version_service.api_client import ApiClient, Endpoint as _Endpoint
from h2o_engine_manager.gen.h2o_version_service.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from h2o_engine_manager.gen.h2o_version_service.model.rpc_status import RpcStatus
from h2o_engine_manager.gen.h2o_version_service.model.v1_list_h2_o_versions_response import V1ListH2OVersionsResponse


class H2OVersionServiceApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.h2_o_version_service_list_h2_o_versions_endpoint = _Endpoint(
            settings={
                'response_type': (V1ListH2OVersionsResponse,),
                'auth': [],
                'endpoint_path': '/v1/h2oVersions',
                'operation_id': 'h2_o_version_service_list_h2_o_versions',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'page_size',
                    'page_token',
                    'order_by',
                    'filter',
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'page_size':
                        (int,),
                    'page_token':
                        (str,),
                    'order_by':
                        (str,),
                    'filter':
                        (str,),
                },
                'attribute_map': {
                    'page_size': 'pageSize',
                    'page_token': 'pageToken',
                    'order_by': 'orderBy',
                    'filter': 'filter',
                },
                'location_map': {
                    'page_size': 'query',
                    'page_token': 'query',
                    'order_by': 'query',
                    'filter': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )

    def h2_o_version_service_list_h2_o_versions(
        self,
        **kwargs
    ):
        """Returns a collection of H2OEngines within a workspace.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.h2_o_version_service_list_h2_o_versions(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            page_size (int): Maximum number of H2OVersions to return in a response. If unspecified (or set to 0), at most 50 H2OVersions will be returned. The maximum value is 1000; values above 1000 will be coerced to 1000.. [optional]
            page_token (str): Leave unset to receive the initial page. To list any subsequent pages use the value of 'next_page_token' returned from the ListH2OVersionsResponse.. [optional]
            order_by (str): Used to specify the sorting order.  When unset, H2OVersions are ordered by their version name in descending order. This is equivalent to \"version desc\".  When specified, the value must be a comma separated list of supported fields. The supported fields are: - version  The default sorting order is ascending. For example: \"version\" and \"version asc\" are equivalent values.  To specify descending order for a field, append a \" desc\" suffix. For example: \"version desc\".  Redundant space characters are insignificant.. [optional]
            filter (str): Used to filter H2OVersions. When unset, no filtering is applied.  Filtering implements specification https://google.aip.dev/160.  Supported filter fields: - version (supporting version semantic comparison and version aliases) - deprecated  Examples: - `version > \"latest\" AND version >= \"3.38.0.1\"` - `deprecated = false`. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            V1ListH2OVersionsResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        return self.h2_o_version_service_list_h2_o_versions_endpoint.call_with_http_info(**kwargs)

